BFD for Multipoint Networks over Point-to-Multi-Point MPLS LSP
Internet-Draft draft-ietf-mpls-p2mp-bfd-07
Greg Mirsky
Ericsson
gregimirsky@gmail.com
Gyan Mishra
Verizon Inc.
gyan.s.mishra@verizon.com
Donald Eastlake, 3rd
Futurewei Technologies
2386 Panoramic Circle
Apopka
FL 32703
USA
d3e3e3@gmail.com
2024
Routing
MPLS Working Group
Internet-Draft
BFD
Multipoint LSP
This document describes procedures for using Bidirectional Forwarding Detection (BFD) for multipoint networks to detect data plane failures in Multiprotocol Label Switching (MPLS) point-to-multipoint (p2mp) Label Switched Paths (LSPs) and Segment Routing (SR) point-to-multipoint policies with SR-MPLS data plane.
Furthermore, this document also updates RFC 8562 and recommends the use of an IPv6 loopback address (:::1/128) and discourages the use of an IPv4 loopback address mapped to IPv6.
It also describes the applicability of LSP Ping, as in-band, and the control plane, as out-band, solutions to bootstrap a BFD session.
It also describes the behavior of the active tail for head notification.
Introduction
[RFC8562] defines a method of using Bidirectional Detection (BFD) [RFC5880] to monitor and detect unicast failures between the sender (head) and one or more receivers (tails) in multipoint or multicast networks.
[RFC8562] added two BFD session types - MultipointHead and MultipointTail. Throughout this document, MultipointHead and MultipointTail refer to the value to which the bfd.SessionType is set on a BFD endpoint.
This document describes procedures for using such modes of BFD protocol to detect data plane failures in Multiprotocol Label Switching (MPLS) point-to-multipoint (p2mp) Label Switched Paths (LSPs) and Segment Routing (SR) point-to-multipoint policies with SR-MPLS data plane
The document also describes the applicability of out-band solutions to bootstrap a BFD session in this environment.
Furthermore, this document also updates [RFC8562] and recommends the use of an IPv6 loopback address (:::1/128) and discourages the use of an IPv4 loopback address mapped to IPv6.
It also describes the behavior of the active tail for head notification.
Conventions used in this document
Terminology
- MPLS: Multiprotocol Label Switching
- LSP: Label Switched Path
- BFD: Bidirectional Forwarding Detection
- p2mp: Point-to-Multipoint
- FEC: Forwarding Equivalence Class
- G-ACh: Generic Associated Channel
- ACH: Associated Channel Header
- GAL: G-ACh Label
- LSR: Label Switching Router
- SR: Segment Routing
- SR-MPLS: SR with MPLS data plane
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Multipoint BFD Encapsulation
[RFC8562] uses BFD in the Demand mode from the very start of a point-to-multipoint (p2mp) BFD session. Because the head doesn't receive any BFD Control packet from a tail, the head of the p2mp BFD session transmits all BFD Control packets with the value of Your Discriminator field set to zero. As a result, a tail cannot demultiplex BFD sessions using Your Discriminator, as defined in [RFC5880]. [RFC8562] requires that to demultiplex BFD sessions, the tail uses the source IP address, My Discriminator, and the identity of the multipoint tree from which the BFD Control packet was received.
If the BFD Control packet is encapsulated in IP/UDP, then the source IP address MUST be used to demultiplex the received BFD Control packet as described in Section 3.1. The non-IP encapsulation case is described in Section 3.2.
IP Encapsulation of Multipoint BFD
[RFC8562] defines IP/UDP encapsulation for multipoint BFD over p2mp MPLS LSP. This document updates [RFC8562] regarding the selection of the IPv6 destination address:
- [RFC4291] defines a single IPv6 loopback address. Hence, for IPv6, the IPv6 loopback address ::1/128 SHOULD be used.
- The sender of an echo request MAY select the IPv6 destination address from the 0:0:0:0:0:FFFF:7F00/104 range.
The Motivation section [RFC6790] lists several advantages of generating the entropy value by an ingress Label Switching Router (LSR) compared to when a transit LSR infers entropy using the information in the MPLS label stack or payload. Thus this specification further clarifies that:
- if multiple alternative paths for the given p2mp LSP Forwarding Equivalence Class (FEC) exist, the MultipointHead SHOULD use the Entropy Label [RFC6790] used for LSP Ping [RFC8029] to exercise those particular alternative paths;
- or the MultipointHead MAY use the UDP port number to possibly exercise those particular alternate paths.
Non-IP Encapsulation of Multipoint BFD
In some environments, the overhead of extra IP/UDP encapsulations may be considered burdensome, making the use of more compact G-ACh encapsulation attractive. Also, the validation of the IP/UDP encapsulation of a BFD Control packet in a p2mp BFD session may fail because of a problem related to neither the MPLS label stack nor to BFD. Avoiding unnecessary encapsulation of p2mp BFD over an MPLS LSP improves the accuracy of the correlation of the detected failure and defect in MPLS LSP. Non-IP encapsulation for multipoint BFD over p2mp MPLS LSP (shown in Figure 1) MUST use Generic Associated Channel (G-ACh) Label (GAL) (see [RFC5586]) at the bottom of the label stack followed by an Associated Channel Header (ACH). If a BFD Control packet in PW-ACH encapsulation (without IP/UDP Headers) is to be used in ACH, an implementation would not be able to verify the identity of the MultipointHead and, as a result, will not properly demultiplex BFD packets. Hence, a new channel type value is needed. The Channel Type field in ACH MUST be set to TBA1 value Section 7. To provide the identity of the MultipointHead for the particular multipoint BFD session, a Source Address TLV, as defined in Section 4.1 [RFC7212], MUST immediately follow a BFD Control message. The use of other TLVs defined in Section 4 of [RFC7212] is outside the scope of this document.
Non-IP Encapsulation for Multipoint BFD Over a Multicast MPLS LSP

    0                   1                   2                   3
    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |               LSP Label               |  TC |S|       TTL     |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                  GAL                  |  TC |1|       TTL     |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |0 0 0 1|Version|   Reserved    |      Channel Type = TBA1      |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   ~                        BFD Control Message                    ~
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |     Type=0    |    Reserved   |            Length             |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |      Reserved (16 bits)       |    Address Family (16 bits)   |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   ~                            Address                            ~
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Bootstrapping Multipoint BFD
LSP Ping
LSP Ping is the part of the on-demand OAM toolset used to detect and localize defects in the data plane and verify the control plane against the data plane by ensuring that the LSP is mapped to the same FEC at both egress and ingress endpoints.
LSP Ping, as defined in [RFC6425], MAY be used to bootstrap MultipointTail. If LSP Ping is used, it MUST include the Target FEC TLV and the BFD Discriminator TLV defined in [RFC5884]. For the case of p2mp MPLS LSP, the Target FEC TLV MUST use sub-TLVs defined in Section 3.1 [RFC6425]. For the case of p2mp SR policy with SR-MPLS data plane, an implementation of this specification MUST follow procedures defined in [RFC8287]. Setting the value of Reply Mode field to "Do not reply" [RFC8029] for the LSP Ping to bootstrap MultipointTail of the p2mp BFD session is RECOMMENDED. Indeed, because BFD over a multipoint network uses BFD Demand mode, the LSP echo reply from a tail has no useful information to convey to the head, unlike in the case of the BFD over a p2p MPLS LSP [RFC5884]. A MultipointTail that receives an LSP Ping that includes the BFD Discriminator TLV:
- MUST validate the LSP Ping;
- MUST associate the received BFD Discriminator value with the p2mp LSP;
- MUST create a p2mp BFD session and set bfd.SessionType = MultipointTail as described in [RFC8562];
- MUST use the source IP address of LSP Ping, the value of BFD Discriminator from the BFD Discriminator TLV, and the identity of the p2mp LSP to properly demultiplex BFD sessions.
Besides bootstrapping a BFD session over a p2mp LSP, LSP Ping SHOULD be used to verify the control plane against the data plane periodically by checking that the p2mp LSP is mapped to the same FEC at the MultipointHead and all active MultipointTails. The rate of generation of these LSP Ping Echo request messages SHOULD be significantly less than the rate of generation of the BFD Control packets because LSP Ping requires more processing to validate the consistency between the data plane and the control plane. An implementation MAY provide configuration options to control the rate of generation of the periodic LSP Ping Echo request messages.
Control Plane
The BGP-BFD Attribute [RFC9026] MAY be used to bootstrap multipoint BFD session on a tail.
Operation of Multipoint BFD with Active Tail over P2MP MPLS LSP
[RFC8562] defined how the BFD Demand mode can be used in multipoint networks. When applied in MPLS, procedures specified in [RFC8562] allow an egress LSR to detect a failure of the part of the MPLS p2mp LSP from the ingress LSR. The ingress LSR is not aware of the state of the p2mp LSP. [RFC8563], using mechanisms defined in [RFC8562], defined an "active tail" behavior. An active tail might notify the head of the detected failure and responds to a poll sequence initiated by the head. The first method, referred to as Head Notification without Polling, is mentioned in Section 5.2.1 [RFC8563], is the simplest of all described in [RFC8563]. The use of this method in BFD over MPLS p2mp LSP is discussed in this document. Analysis of other methods of a head learning of the state of an MPLS p2mp LSP is outside the scope of this document.
As specified in [RFC8563] for the active tail mode, BFD variables MUST be as follows:
On an ingress LSR:
- bfd.SessionType is MultipointHead;
- bfd.RequiredMinRxInterval is set to nonzero, allowing egress LSRs to send BFD Control packets.
On an egress LSR:
- bfd.SessionType is MultipointTail;
- bfd.SilentTail is set to zero.
In Section 5.2.1 [RFC8563] is noted that "the tail sends unsolicited BFD packets in response to the detection of a multipoint path failure" but without the specifics on the information in the packet and frequency of transmissions. This document defines below the procedure of an active tail with unsolicited notifications for p2mp MPLS LSP.
Upon detecting the failure of the p2mp MPLS LSP, an egress LSR sends BFD Control packet with the following settings:
- the Poll (P) bit is set;
- the Status (Sta) field set to Down value;
- the Diagnostic (Diag) field set to Control Detection Time Expired value;
- the value of the Your Discriminator field is set to the value the egress LSR has been using to demultiplex that BFD multipoint session;
- BFD Control packet MAY be encapsulated in IP/UDP with the destination IP address of the ingress LSR and the UDP destination port number set to 4784 per [RFC5883]. If non-IP encapsulation is used, then a BFD Control packet is encapsulated using PW-ACH encapsulation (without IP/UDP Headers) with Channel Type 0x0007 [RFC5885];
- these BFD Control packets are transmitted at the rate of one per second until either it receives a control packet valid for this BFD session with the Final (F) bit set from the ingress LSR or the defect condition clears. However, to improve the likelihood of notifying the ingress LSR of the failure of the p2mp MPLS LSP, the egress LSR SHOULD initially transmit three BFD Control packets defined above in short succession. The actual transmission of the periodic BFD Control message MUST be jittered by up to 25% within one-second intervals. Thus, the interval MUST be reduced by a random value of 0 to 25%, to reduce the possibility of congestion on the ingress LSR's data and control planes.
As described above, an ingress LSR that has received the BFD Control packet sends the unicast IP/UDP encapsulated BFD Control packet with the Final (F) bit set to the egress LSR. In some scenarios, e.g., when a p2mp LSP is broken close to its root, and the number of egress LSRs is significantly large, the root might receive a large number of notifications. The notifications from leaves to the root will not use DetNet resources and, as a result, will not congest DetNet flows, although they may negatively affect other flows. However, the control plane of the ingress LSR might be congested by the BFD Control packets transmitted by egress LSRs and the process of generating unicast BFD Control packets, as noted above. To mitigate that, a BFD implementation that supports this specification is RECOMMENDED to use a rate limiter of received BFD Control packets passed to the ingress LSR’s control plane for processing.
Security Considerations
This document does not introduce new security considerations but inherits all security considerations from [RFC5880], [RFC5884], [RFC7726], [RFC8562], [RFC8029], and [RFC6425].
Also, BFD for p2mp MPLS LSP MUST follow the requirements listed in section 4.1 [RFC4687] to avoid congestion in the control plane or the data plane caused by the rate of generating BFD Control packets. An operator SHOULD consider the amount of extra traffic generated by p2mp BFD when selecting the interval at which the MultipointHead will transmit BFD Control packets. The operator MAY consider the size of the packet the MultipointHead transmits periodically as using IP/UDP encapsulation, which adds up to 28 octets, more than 50% of the BFD Control packet length, comparing to G-ACh encapsulation.
IANA Considerations
IANA is requested to allocate value (TBA1) from its MPLS Generalized Associated Channel (G-ACh) Types registry.
Multipoint BFD Session G-ACh Type
Value | Description | Reference
TBA1 | Multipoint BFD Session | This document
Acknowledgements
The authors sincerely appreciate the comments received from Andrew Malis, Italo Busi, Shraddha Hegde, and thought stimulating questions from Carlos Pignataro.
References
Normative References
Informative References
[RFC8562]
[RFC5880]
[RFC2119]
[RFC8174]
[RFC4291]
[RFC6790]
[RFC8029]
[RFC5586]
[RFC7212]
[RFC6425]
[RFC5884]
[RFC8287]
[RFC9026]
[RFC8563]
[RFC5883]
[RFC5885]
[RFC7726]
[RFC4687]